#!/usr/bin/env python3
# encoding: utf-8
# api: pip
# type: build
# title: config for setuptools
#
# Always prefer setuptools over distutils
#

from pluginconf.setup import setup

setup(
    debug=1,
    fn="dingonyms.py",
    #long_description="README.md",
    packages=[""],
    package_dir={"": "."},
    py_modules=['dingonyms'],
    entry_points={
        "console_scripts": [
            "dingonyms=dingonyms:__main__",
            "dictcc=dingonyms:dictcc",
        ]
    }
)
