# encoding: utf-8
import pytest, os
import translationbackends as tb

# semi fixture
kw = {
    "lang": "fr",
    "from": "de",
    "email": os.environ.get("EMAIL"),
}


@pytest.mark.often_yields_none
def mymem(params):
    params.update(kw)
    t = tb.MyMemory(**params)
    assert t.translate("apfelkuchen") == "Tarte aux pommes"


