#!/usr/bin/env python3
# encoding: utf-8
# api: pip
# type: build
# title: config for setuptools
#
# Always prefer setuptools over distutils
#

from pluginconf.setup import setup

setup(
    debug=1,
    fn="tk_translate/__init__.py",
    name="tk_translate",
    packages=["tk_translate"],
    package_dir={"": "."},
    entry_points={
        "console_scripts": [
            "tk_translate=tk_translate:main",
        ]
    },
    extras_require={
        "build": ["pluginconf","setuptools"],
        "unused": ["ttkthemes"]
    },
#    universal=True
)
